/*
 * vms name.c
 */

#include <linux/fs.h>
#include <linux/errno.h>
#include "vms_fs.h"
#include "vms_fs_i.h"

/*extern unsigned int vms_bmap(struct inode * inode, int block); /* XXX */

/*
 * NOTE! unlike strncmp, ext2_match returns 1 for success, 0 for failure.
 * stolen from ext2fs
 */
static int vms_match (int len, const char * const name, struct vms_directory * d) {
	if (!d || len > VMS_MAXNAMLEN)
		return 0;
	/*
	 * "" means "." ---> so paths like "/usr/lib//libc.a" work
	 */
	if (!len && (d->d_nbc == 1) && (d->d_fname[0] == '.') &&
	   (d->d_fname[1] == '\0'))
		return 1;
	if (len != d->d_nbc)
		return 0;
	return !memcmp(name, d->d_fname, len);
}

/* XXX - this is a mess, especially for endianity */
int vms_lookup (struct inode * dir, const char * name, int len,
	        struct inode ** result)
{
	int offset,block,ino;
	struct super_block *s;
	struct vms_directory *vmd;
	struct vms_inode_info *vii;
	struct vms_header *dh;
	char dirbuf[VMS_BLOCKSIZE];

	s = dir->i_sb;

	printk("vms_lookup: '%s' - ",name);

	*result = NULL;

	if(!dir || !S_ISDIR(dir->i_mode)) return(-ENOENT);

	if(name[0] == '.') {
		if(name[1] == 0) {
			printk(".\n");
			if(!(*result = iget(s,dir->i_ino))) {
				printk("fuck\n");
				iput(dir);
				return(-EACCES);
			}
			return(0);
		}
		if(name[1] == '.' && name[2] == 0) {
			printk("..\n");
			if(!(*result = iget(s,VMS_ROOT_INO))) {
				printk("fuck\n");
				iput(dir);
				return(-EACCES);
			}
			return(0);
		}
	}

	vii = (struct vms_inode_info *)dir->u.generic_ip;
	dh = &vii->header;

	block = 1;
	offset = 0;

	while(block <= dh->h_use) {	/* XXX is this right? */
		struct vms_dirval *dv;
		int nextblock;

		if(!getvb(block,dirbuf,dh,s->s_dev)) {
			return(-EIO);
		}

		nextblock = 0;

		while(!nextblock) {
			printk("block:%i offset:%i\n",block,offset);

			vmd = (struct vms_directory *)(dirbuf + offset);
			if(vmd->d_rbc == (ushort)-1) {
				block++;
				offset = 0;
				nextblock = 1;
				continue;
			}

			dv = (struct vms_dirval *)(vmd->d_fname + vmd->d_nbc);
			ino = dv->d_fid.f_num;

			printk("%s:%i ",vmd->d_fname,ino);
			if(len == vmd->d_nbc) {
				if(vms_match(len,name,vmd)) {
					printk("match: '%s':%i\n",vmd->d_fname,ino);
					if(!(*result = iget(s,ino))) {
						printk("failed.\n");
						iput(dir);
						return(-EACCES);
					}
					return(0);
				}
			}

			offset += vmd->d_rbc;
			if(offset >= VMS_BLOCKSIZE) {
				block++;
				offset -= VMS_BLOCKSIZE;
				nextblock = 1;
			}
		}
	}

	printk("'%s'?\n",name);
	iput(dir);
	return(-ENOENT);
}

